<?php
/** @file
 * Configuration file for viewgit.
 *
 * @note DO NOT EDIT THIS FILE. Create localconfig.php instead and override the settings in it.
 */
$conf['projects'] = array(
	// 'name' => array('repo' => '/path/to/repo'),
);

// Where git is. Default is to search from PATH, but you can use an absolute
// path as well.
$conf['git'] = 'git';

// If set, contains an array of globs/wildcards where to include projects.
// Use this if you have a lot of projects under a directory.
//$conf['projects_glob'] = array('/path/to/*/.git', '/var/git/*.git');

$conf['datetime'] = '%Y-%m-%d %H:%M';

// More complete format for commit page
$conf['datetime_full'] = '%Y-%m-%d %H:%M:%S';

// Maximum length of commit message's first line to show 
$conf['commit_message_maxlen'] = 50;

// Maximum number of shortlog entries to show on the summary page
$conf['summary_shortlog'] = 30;

// Maximum number of tags to show on the summary page
$conf['summary_tags'] = 10;

// Whether to show remote labels on shortlog
$conf['shortlog_remote_labels'] = false;

// Allow checking out projects via "git clone"
$conf['allow_checkout'] = true;

// If set, this function is used to obfuscate e-mail addresses of authors/committers
// The 'obfuscate_mail' function simply replaces @ with ' at ' and . with ' dot '
//$conf['mail_filter'] = 'obfuscate_mail';
//$conf['mail_filter'] = create_function('$mail', 'return str_rot13(strtoupper($mail));');

// Whether to use GeSHi for source highlighting
$conf['geshi'] = false;

// Path to geshi.php
//$conf['geshi_path'] = 'inc/geshi/geshi.php';
//$conf['geshi_path'] = '/usr/share/php-geshi/geshi.php'; // Path on Debian

// Use line numbers in geshi?
// Setting this to "false" disables line numbers
// Using a value of 0 will enable "NORMAL" geshi line numbers
// Using values of 1 or more will enable "FANCY" geshi line numbers
$conf['geshi_line_numbers'] = 5;

// RSS time to live (how often clients should update the feed), in minutes.
$conf['rss_ttl'] = 10;

// RSS: Maximum number of items in feed
$conf['rss_max_items'] = 30;

// RSS item format. Allowed formatting:
// {AUTHOR}, {AUTHOR_MAIL}, {SHORTLOG}, {LOG}, {COMMITTER}, {COMMITTER_MAIL}, {DIFFSTAT}
$conf['rss_item_title'] = '{SHORTLOG} ({AUTHOR})';
$conf['rss_item_description'] = '<pre>{LOG}</pre><b>{AUTHOR}</b> &lt;{AUTHOR_MAIL}&gt;<br /><pre>{DIFFSTAT}</pre>';

$conf['debug'] = false;

// Includes a small link to the ViewGit homepage on each page
$conf['ad'] = true;

// If auth_lib is set, inc/auth_<auth_lib>.php must exist and include a function
// named auth_check(). The function should check any required global variables
// (such as $_REQUEST, $_SERVER['PHP_AUTH_USER']) and die() if access is denied.

// For a simple username/password authorisation you can use auth_simple, see
// inc/auth_simple.php for more info. The array is username => md5 hash.
//$conf['auth_lib'] = 'simple';
//$conf['auth_simple_users'] = array('test' => 'd7b58f27f98f47bacd60fa87efe822ba');

// Uncomment the following lines to authenticate using some drupal site's
// config
//$conf['auth_lib'] = 'drupal_user';
//$conf['drupal_site_config'] = '/var/www/sites/default/settings.php';

// Which stylesheet to use
$conf['style'] = 'default';

if (!@include_once('localconfig.php')) {
	die('ViewGit has not been configured yet, please read doc/README.');
}
